return;
const { fs } = require('./bootstrap/modules');
const { EOL } = require('os');

let filesList = [];

for (let file of resources.jsFiles) {
    // if (file.includes('DependencyInjection')) continue;
    filesList.push(ROOT + '/' + file.ltrim('/'));
}

let depsList = {};

let classMap = {};

let DIContent = null;

for (let i = 0; i < filesList.length; i++) {
    let file = filesList[i];

    let fileContent = fs.get(file).trim();

    if (file.includes('injection')) {
        DIContent = fileContent;
    }

    if (!file.includes('-injection') && fileContent.includes('DI.register({')) {
        handleDIOf(DIContent, fileContent);
    }

    if (fileContent.startsWith('class ')) {
        let className;
        fileContent.replace(/class ([^\{|\s]+)/, function (text, classNameString) {
            className = classNameString;
        });

        let classInfo = {
            className,
            alias: getAlias(fileContent, className),
            dependencies: getDep(fileContent),
        };

        depsList[className] = classInfo;

        if (classInfo.alias) {
            depsList[classInfo.alias] = classInfo;
        }
    }
}

function handleDIOf(DIContent, fileContent) {
    let c = [];

    for (let line of fileContent.split("\n")) {
        line = line.trim();
        if (line.includes('DI.register')) break;
        
        c.push(line);
    }

    echo(c.join(EOL));

    require(ROOT + '/di.js')(fileContent);


    die();
}

function getAlias(fileContent, className) {
    let lines = fileContent.split("\n");

    for (let line of lines) {
        line = line.trim();

        if (className == 'AuthService') echo(line, '-_-');

        if (line.startsWith('alias')) {
            let alias = line.replaceAll("'", '').replace(',', '').replace(/alias(\s)*:(\s)*/, '');
            return alias;
        }
    }

    return null;
}

function getDep(code) {
    let regexExp = '';

    let methodText = code;
    let methodName = 'constructor';

    regexExp += '(?:' + methodName + ')';

    regexExp += '\\s*\\(([^\\)]*)\\)';

    let regex = new RegExp(regexExp),
        matches = methodText.match(regex);

    if (!matches || !matches[1]) return [];

    // now we will remove any spaces, tabs or new lines
    return matches[1].replace(/\t|\n|\s/g, '').replace(/,$/, '').split(',');
}
const util = require('util');

echo()
die(depsList);